## raul 0.6.0

=== wscript ===
#!/usr/bin/env python
import autowaf
import Options

# Version of this package (even if built as a child)
RAUL_VERSION = '0.6.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.4.0 = 0,0,0
#   0.5.0 = 1,0,0 (SVN r1283)
#   0.5.1 = 2,0,0
#   0.6.0 = 3,0,0
RAUL_LIB_VERSION = '3.0.0'

# Variables for 'waf dist'
APPNAME = 'raul'
VERSION = RAUL_VERSION

# Mandatory variables
srcdir = '.'
blddir = 'build'

def set_options(opt):
	autowaf.set_options(opt)
	opt.add_option('--test', action='store_true', default=False, dest='build_tests',
			help="Build unit tests")

def configure(conf):
	autowaf.configure(conf)
	conf.check_tool('compiler_cxx')
	autowaf.check_pkg(conf, 'glib-2.0', atleast_version='2.2',
			uselib_store='GLIB', mandatory=True)
	autowaf.check_pkg(conf, 'gthread-2.0', atleast_version='2.14.0',
			uselib_store='GTHREAD', mandatory=True)
	
	conf.env['BUILD_TESTS'] = Options.options.build_tests

	# Boost headers
	autowaf.check_header(conf, 'boost/shared_ptr.hpp', mandatory=True)
	autowaf.check_header(conf, 'boost/weak_ptr.hpp', mandatory=True)
	autowaf.check_header(conf, 'boost/utility.hpp', mandatory=True)
	
	autowaf.print_summary(conf)
	autowaf.display_msg(conf, "Unit tests", str(conf.env['BUILD_TESTS']))
	print

def build(bld):
	# Headers
	bld.install_files('${INCLUDEDIR}/raul', 'raul/*.hpp')
	bld.install_files('${INCLUDEDIR}/raul', 'raul/*.h')

	# Pkgconfig file
	autowaf.build_pc(bld, 'RAUL', RAUL_VERSION, 'GLIBMM GTHREAD')

	# Library
	obj = bld.new_task_gen('cxx', 'shlib')
	obj.source = '''
		src/Maid.cpp
		src/Path.cpp
		src/SMFReader.cpp
		src/SMFWriter.cpp
		src/Symbol.cpp
		src/Thread.cpp
	'''
	obj.export_incdirs = ['.']
	obj.includes     = ['.', './src']
	obj.name         = 'libraul'
	obj.target       = 'raul'
	obj.uselib       = 'GLIBMM GTHREAD'
	obj.install_path = '${LIBDIR}'
	obj.vnum         = RAUL_LIB_VERSION

	# Unit tests
	bld.add_subdirs('tests')

	# Documentation
	autowaf.build_dox(bld, 'RAUL', RAUL_VERSION, srcdir, blddir)
	bld.install_files('${HTMLDIR}', blddir + '/default/doc/html/*')

def shutdown():
	autowaf.shutdown()

=== tests/wscript ===
#!/usr/bin/env python

def build(bld):
	tests = '''
		path_test
		thread_test
		queue_test
		ringbuffer_test
		midi_ringbuffer_test
		atomic_test
		list_test
		time_test
		quantize_test
		smf_test
		table_test
	'''
	if bld.env['BUILD_TESTS']:
		for i in tests.split():
			obj = bld.new_task_gen('cxx', 'program')
			obj.source       = i + '.cpp'
			obj.includes     = '..'
			obj.uselib_local = 'libraul'
			obj.target       = i
			obj.install_path = ''

=== debian/changelog ===
raul (0.6.0-1ubuntu2) lucid; urgency=low

  * Add python to Build-Depends.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Sun, 28 Feb 2010 13:14:37 +0100

raul (0.6.0-1ubuntu1) lucid; urgency=low

  * Use internal copy of waf.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Sat, 27 Feb 2010 15:22:20 +0100

raul (0.6.0-1) unstable; urgency=low

  * New upstream release (closes: #562631)
  * debian/control:
    - add build-depends on waf
    - drop libjack-dev, switch from gtkmm glib
    - switch package maintenance to git
    - drop quilt
    - tighten debhelper to >= 7.0.50~
    - bump libraul soname to 3
    - add libraul-doc package
  * debian/rules:
    - merge with flowcanvas to use waf
    - drop quilt
    - factorise waf options
    - install doc in libraul-doc
  * debian/libraul-doc.install: install libraul-doc html files
  * debian/libraul-doc.doc-base: register documentation with doc-base
  * debian/control: add build-depends on graphviz

 -- Paul Brossier <piem@debian.org>  Sun, 27 Dec 2009 01:32:40 +0100

raul (0.5.1-2) unstable; urgency=low

  * Add build-depends on quilt
  * Add patch to fix FTBFS with g++-4.4, thanks to Michael Bienia
   (closes: #559889)

 -- Paul Brossier <piem@debian.org>  Mon, 07 Dec 2009 17:25:36 +0100

raul (0.5.1-1) unstable; urgency=low

  * Initial release (closes: #553377)

 -- Paul Brossier <piem@debian.org>  Fri, 30 Oct 2009 18:40:07 +0100

=== debian/control ===
Source: raul
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paul Brossier <piem@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
               python (>= 2.5),
               libglib2.0-dev,
               libboost-dev,
               doxygen,
               graphviz
Standards-Version: 3.8.3
Section: libs
Vcs-Git: git://git.debian.org/collab-maint/raul.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/raul.git;a=summary
Homepage: http://drobilla.net/software/raul/

Package: libraul-dev
Section: libdevel
Architecture: any
Depends: libraul3 (= ${binary:Version}), ${misc:Depends}
Description: real time audio utility library -- development files
 Raul (Realtime Audio Utility Library) is a C++ utility library primarily aimed
 at audio/musical applications.
 .
 This package contains the development files for libraul.

Package: libraul3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: real time audio utility library
 Raul (Realtime Audio Utility Library) is a C++ utility library primarily aimed
 at audio/musical applications.
 .
 This package provides the shared library libraul.

Package: libraul-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: real time audio utility library -- documentation
 Raul (Realtime Audio Utility Library) is a C++ utility library primarily aimed
 at audio/musical applications.
 .
 This package provides the documentation for raul.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WAFOPTS = --prefix=/usr --destdir=$(CURDIR)/debian/tmp --strict --verbose --build-docs --htmldir=/usr/share/doc/libraul-doc/html

%:
	dh $@

override_dh_auto_configure:
	./waf configure $(WAFOPTS)

override_dh_auto_build:
	dh build --before dh_auto_build
	./waf build $(WAFOPTS)
	dh build --after dh_auto_build

override_dh_auto_install:
	dh install --before dh_auto_install
	./waf install $(WAFOPTS)
	dh install --after dh_auto_install

override_dh_auto_clean:
	dh clean --before dh_auto_clean
	./waf distclean $(WAFOPTS)
	-$(RM) -f autowaf.pyc
	dh clean --after dh_auto_clean

## raul 0.8.0

=== debian/changelog ===
raul (0.8.0-0.3) unstable; urgency=low

  * Non-maintainer upload.
  * Upload to unstable (Closes: #628665):
    - Allow the new stable release of patchage doing the same.
    - The 0.6.0 branch is too ancient, moreover upstream doesn't support it
      anymore.

 -- Alessio Treglia <alessio@debian.org>  Wed, 01 Jun 2011 12:16:00 +0200

raul (0.8.0-0.2) experimental; urgency=low

  * Non-maintainer upload.
  * debian/rules:
    - Build docs only when doxygen, graphviz are installed;
      this also fixes FTBFS on kfreebsd-amd64 (Closes: #624409).
    - Build with --debug enabled.
  * debian/control:
    - Move doxygen, graphviz to Build-Depends-Indep.
    - Sort Build-Depends values.
  * debian/patches/1001-dont_run_ldconfig.patch:
    - Avoid calling ldconfig once the build is finished, this allow us
      to save a bit of time.
  * Remove debian/patches/hppa_parallel.patch since it is unneeded now.

 -- Alessio Treglia <alessio@debian.org>  Thu, 28 Apr 2011 12:46:11 +0200

raul (0.8.0-0.1) experimental; urgency=low

  * Non-maintainer upload.
  * New upstream release (Closes: #611193):
    - Changes in 0.8.0:
      + Implement Semaphore for Darwin
      + Remove unused/trivial/inappropriate Command and Stateful
      + Remove pointless templateification of RingBuffer
      + Use uint32_t consistently for sizes in RingBuffer
      + Fix off-by-one allocation of Atom strings
      + Add all classes to 'raul' doxygen group
      + Make single-argument constructors explicit
      + Fix incorrect TimeSlice::beats_to_ticks
      + Fix crash bug in List::chop_front
      + Fix TimeStamp comparison operators
      + Rename LOG_ + defines RAUL_LOG_ +
      + Remove "using namespace" declarations
      + Add missing #includes
      + Add missing COPYING file to distribution
      + Upgrade to waf 1.6.2
      + Fix accidental build system dependency on glibmm (now glib only)
      + Better documentation generation via waf tool
    - Changes 0.7.0:
      + Add several unit tests
      + Use malloc'd memory for RingBuffer/SRSWQueue (instead of a new'd
        array)
      + Fancy coloured console/logging I/O (raul/log.hpp)
      + More flexible Path and better URI support
      + Atom updates, including new "Blank" Atom for storing dictionaries
        with URI keys (ala JavaScript "objects", but RDF compatible)
      + Remove stack stuff from Array and create new ArrayStack
      + Make Symbol and URI more opaque and use Glib string interning
      + Add Configuration class for app command line option handling
      + Use < operator in TableImpl instead of > so it needn't be defined
      + Add IntrusivePtr, a trivial #define of boost::intrusive_ptr which
        is useful for hard realtime things (since adding and dropping refs
        is realtime safe, which is not true of shared_ptr)
      + Remove TimeSlice
  * SONAME change: libraul3 -> libraul10.
  * Fix lintian's embedded-javascript-library warning on libraul-doc:
    - Symlink jquery.js to /usr/share/doc/libraul-doc/html/jquery.js rather
      than install a local copy.
  * debian/control:
    - Bump Standards.
    - Remove duplicate Section: libs.
    - Make libraul-doc depend on libjs-jquery.
    - Make libraul-dev depend on libglib2.0-dev,libboost-dev and suggest
      liblo-dev.
  * debian/copyright:
    - Add license and copyright information about waf,raul/midi_events.h
      files.
    - Update to DEP-5 svn rev.174.
  * debian/rules:
    - No need to apply hppa_parallel.patch anymore since hppa arch was
      dropped.
    - Rewrote to use pure DH7 short-form.
  * Remove unneeded debian/libraul3.dirs file.

 -- Alessio Treglia <alessio@debian.org>  Tue, 12 Apr 2011 14:36:26 +0200

raul (0.6.0-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * debian/patches/hppa_parallel.patch:
    - Disable parallel build on hppa (Fixes: #561130).
  * debian/rules:
    - Patch affected files on-the-fly.

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 09 May 2010 16:21:36 +0000

raul (0.6.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Use convenience copy of waf, system wide waf package is being removed
    from Debian (Closes: #571708).
  * Build-depend on python, convenience copy of waf needs it.

 -- Luca Falavigna <dktrkranz@debian.org>  Sun, 11 Apr 2010 16:34:33 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
EXTRA_OPTS = --docs
endif

WAFOPTS = --prefix=/usr \
	--destdir=$(CURDIR)/debian/tmp \
	--debug \
	--strict \
	--verbose \
	--htmldir=/usr/share/doc/libraul-doc/html \
	$(EXTRA_OPTS)

%:
	dh $@

override_dh_auto_configure:
	./waf configure $(WAFOPTS)

override_dh_auto_build:
	./waf build $(WAFOPTS)

override_dh_auto_install:
	./waf install $(WAFOPTS)
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/libraul-doc/html/jquery.js

override_dh_auto_clean:
	./waf distclean
	-$(RM) -f autowaf/autowaf.pyc
	dh_auto_clean

## raul 0.8.0%2Bdfsg0

=== debian/control ===
Source: raul
Priority: extra
Maintainer: Paul Brossier <piem@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
 libboost-dev,
 libglib2.0-dev,
 python
Build-Depends-Indep: doxygen,
 graphviz
Standards-Version: 3.9.2
Section: libs
Vcs-Git: git://git.debian.org/collab-maint/raul.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/raul.git;a=summary
Homepage: http://drobilla.net/software/raul/

Package: libraul-dev
Section: libdevel
Architecture: any
Depends: libraul10 (= ${binary:Version}),
 libglib2.0-dev,
 libboost-dev,
 ${misc:Depends}
Suggests: liblo-dev
Description: real time audio utility library -- development files
 Raul (Realtime Audio Utility Library) is a C++ utility library primarily aimed
 at audio/musical applications.
 .
 This package contains the development files for libraul.

Package: libraul10
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: real time audio utility library
 Raul (Realtime Audio Utility Library) is a C++ utility library primarily aimed
 at audio/musical applications.
 .
 This package provides the shared library libraul.

Package: libraul-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
 libjs-jquery
Description: real time audio utility library -- documentation
 Raul (Realtime Audio Utility Library) is a C++ utility library primarily aimed
 at audio/musical applications.
 .
 This package provides the documentation for raul.

## raul 0.8.0+dfsg0

=== wscript ===
#!/usr/bin/env python
import autowaf
import Options
import os

# Version of this package (even if built as a child)
RAUL_VERSION = '0.8.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.4.0 = 0,0,0
#   0.5.0 = 1,0,0 (SVN r1283)
#   0.5.1 = 2,0,0
#   0.6.0 = 3,0,0
#   0.6.1 = 4,0,0 (unreleased)
#   0.6.2 = 5,0,0 (unreleased)
#   0.6.3 = 6,0,0 (unreleased)
#   0.6.4 = 7,0,0 (unreleased)
#   0.6.5 = 8,0,0 (unreleased)
#   0.6.6 = 9,0,0 (unreleased)
#   0.7.0 = 9,0,0
#   0.8.0 = 10,0,0
RAUL_LIB_VERSION = '10.0.0'

# Variables for 'waf dist'
APPNAME = 'raul'
VERSION = RAUL_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
	autowaf.set_options(opt)
	opt.add_option('--test', action='store_true', default=False, dest='build_tests',
			help="Build unit tests")
	opt.add_option('--log-colour', action='store_true', default=True, dest='log_colour',
			help="Coloured console/log output")
	opt.add_option('--log-debug', action='store_true', default=False, dest='log_debug',
			help="Print debugging output")

def configure(conf):
	autowaf.configure(conf)
	autowaf.display_header('Raul Configuration')
	conf.check_tool('compiler_cxx')
	autowaf.check_pkg(conf, 'glib-2.0', atleast_version='2.2',
					  uselib_store='GLIB', mandatory=True)
	autowaf.check_pkg(conf, 'gthread-2.0', atleast_version='2.14.0',
					  uselib_store='GTHREAD', mandatory=True)
	
	if Options.platform == 'darwin':
		conf.check(framework_name='CoreServices')
		conf.env['FRAMEWORK_RAUL'] = ['CoreServices']

	conf.env['BUILD_TESTS'] = Options.options.build_tests

	if Options.options.log_colour:
		autowaf.define(conf, 'RAUL_LOG_COLOUR', 1)
	if Options.options.log_debug:
		autowaf.define(conf, 'RAUL_LOG_DEBUG', 1)

	conf.write_config_header('raul-config.h', remove=False)

	# Boost headers
	autowaf.check_header(conf, 'boost/shared_ptr.hpp', mandatory=True)
	autowaf.check_header(conf, 'boost/weak_ptr.hpp', mandatory=True)
	autowaf.check_header(conf, 'boost/utility.hpp', mandatory=True)
	
	autowaf.display_msg(conf, "Unit tests", str(conf.env['BUILD_TESTS']))
	print
	
tests = '''
	test/atom_test
	test/atomic_test
	test/list_test
	test/midi_ringbuffer_test
	test/path_test
	test/quantize_test
	test/queue_test
	test/ringbuffer_test
	test/smf_test
	test/table_test
	test/thread_test
	test/time_test
'''

def build(bld):
	# Headers
	bld.install_files('${INCLUDEDIR}/raul', bld.path.ant_glob('raul/*.hpp'))
	bld.install_files('${INCLUDEDIR}/raul', bld.path.ant_glob('raul/*.h'))

	# Pkgconfig file
	dict = {'RAUL_PC_LIBS': ' '}
	if Options.platform == 'darwin':
		dict = {'RAUL_PC_LIBS': '-framework CoreServices'}
	autowaf.build_pc(bld, 'RAUL', RAUL_VERSION, 'GLIB GTHREAD', subst_dict=dict)

	lib_source = '''
		src/Configuration.cpp
		src/Maid.cpp
		src/Path.cpp
		src/SMFReader.cpp
		src/SMFWriter.cpp
		src/Symbol.cpp
		src/Thread.cpp
		src/log.cpp
	'''

	framework = ''
	if Options.platform == 'darwin':
		framework = ' CoreServices '

	# Library
	obj = bld(features = 'cxx cxxshlib')
	obj.export_includes = ['.']
	obj.source          = lib_source
	obj.includes        = ['.', './src']
	obj.name            = 'libraul'
	obj.target          = 'raul'
	obj.uselib          = 'GLIB GTHREAD'
	obj.framework       = framework
	obj.install_path    = '${LIBDIR}'
	obj.vnum            = RAUL_LIB_VERSION

	if bld.env['BUILD_TESTS']:
		# Static library (for unit test code coverage)
		obj = bld(features = 'cxx cxxstlib')
		obj.source       = lib_source
		obj.includes     = ['.', './src']
		obj.name         = 'libraul_static'
		obj.target       = 'raul_static'
		obj.uselib       = 'GLIB GTHREAD'
		obj.framework    = framework
		obj.install_path = ''
		obj.cxxflags     = [ '-fprofile-arcs',  '-ftest-coverage' ]

		# Unit tests
		for i in tests.split():
			obj = bld(features = 'cxx cxxprogram')
			obj.source       = i + '.cpp'
			obj.includes     = ['.', './src']
			obj.use          = 'libraul_static'
			obj.uselib       = 'GLIB GTHREAD'
			obj.framework    = framework
			obj.target       = i
			obj.install_path = ''
			obj.cxxflags     = [ '-fprofile-arcs',  '-ftest-coverage' ]
			obj.linkflags    = ['-lgcov']

	# Documentation
	autowaf.build_dox(bld, 'RAUL', RAUL_VERSION, top, out)

	bld.add_post_fun(autowaf.run_ldconfig)

def test(ctx):
	autowaf.run_tests(ctx, APPNAME, tests.split())

=== debian/changelog ===
raul (0.8.0+dfsg0-0.1ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 04 Aug 2015 11:38:59 +0100

raul (0.8.0+dfsg0-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * Repack upstream tarball to get rid of the 'waf' blob (Closes: #654498):
    - debian/rules:
      + Use 'waf clean' instead of 'waf distclean' to prevent the waflib
        directory to be deleted.
      + Prune *.pyc files and skip errors on clean.

 -- Alessio Treglia <alessio@debian.org>  Tue, 10 Jan 2012 11:01:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: raul
 Priority: extra
-Maintainer: Paul Brossier <piem@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Paul Brossier <piem@debian.org>
 Build-Depends: debhelper (>= 7.0.50~),
  libboost-dev,
  libglib2.0-dev,
@@ -16,7 +17,7 @@
 Package: libraul-dev
 Section: libdevel
 Architecture: any
-Depends: libraul10 (= ${binary:Version}),
+Depends: libraul10v5 (= ${binary:Version}),
  libglib2.0-dev,
  libboost-dev,
  ${misc:Depends}
@@ -27,9 +28,11 @@
  .
  This package contains the development files for libraul.
 
-Package: libraul10
+Package: libraul10v5
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libraul10
+Replaces: libraul10
 Description: real time audio utility library
  Raul (Realtime Audio Utility Library) is a C++ utility library primarily aimed
  at audio/musical applications.

=== debian/rules ===
--- 
+++ 
@@ -30,6 +30,6 @@
 	rm -f $(CURDIR)/debian/tmp/usr/share/doc/libraul-doc/html/jquery.js
 
 override_dh_auto_clean:
-	./waf distclean
-	-$(RM) -f autowaf/autowaf.pyc
+	./waf clean || true
+	find -name "*.pyc" -delete
 	dh_auto_clean

=== debian/watch ===
version=3
http://drobilla.net/software/raul/ \
  http://download.drobilla.net/raul-(.*)\.tar\.gz
